Functions

# Variance
[Statistics Functions]

## Functions
void | arm_var_f32 (float32_t *pSrc, uint32_t blockSize, float32_t *pResult)
void | arm_var_q31 (q31_t *pSrc, uint32_t blockSize, q63_t *pResult)
void | arm_var_q15 (q15_t *pSrc, uint32_t blockSize, q31_t *pResult)

## Detailed Description

Calculates the variance of the elements in the input vector. The underlying algorithm is used:

     	Result = (sumOfSquares - sum2 / blockSize) / (blockSize - 1)

    	   where, sumOfSquares = pSrc[0] * pSrc[0] + pSrc[1] * pSrc[1] + ... + pSrc[blockSize-1] * pSrc[blockSize-1]

    	                   sum = pSrc[0] + pSrc[1] + pSrc[2] + ... + pSrc[blockSize-1]

There are separate functions for floating point, Q31, and Q15 data types.

## Function Documentation

void arm_var_f32 | ( | float32_t * | pSrc,
|  | uint32_t | blockSize,
|  | float32_t * | pResult
| ) |  |

Variance of the elements of a floating-point vector.

Parameters:

  [in] | *pSrc | points to the input vector
  [in] | blockSize | length of the input vector
  [out] | *pResult | variance value returned here

Returns:
  none.

Examples:
  arm_class_marks_example_f32.c.

Definition at line 66 of file arm_var_f32.c.

void arm_var_q31 | ( | q31_t * | pSrc,
|  | uint32_t | blockSize,
|  | q63_t * | pResult
| ) |  |

Variance of the elements of a Q31 vector.

Parameters:

  [in] | *pSrc | points to the input vector
  [in] | blockSize | length of the input vector
  [out] | *pResult | variance value returned here

Returns:
  none.

Scaling and Overflow Behavior:

  The function is implemented using an internal 64-bit accumulator. The input is represented in 1.31 format, and intermediate multiplication yields a 2.62 format. The accumulator maintains full precision of the intermediate multiplication results, but provides only a single guard bit. There is no saturation on intermediate additions. If the accumulator overflows it wraps around and distorts the result. In order to avoid overflows completely the input signal must be scaled down by log2(blockSize) bits, as a total of blockSize additions are performed internally. Finally, the 2.62 accumulator is right shifted by 31 bits to yield a 1.31 format value.

Definition at line 63 of file arm_var_q31.c.

void arm_var_q15 | ( | q15_t * | pSrc,
|  | uint32_t | blockSize,
|  | q31_t * | pResult
| ) |  |

Variance of the elements of a Q15 vector.

Parameters:

  [in] | *pSrc | points to the input vector
  [in] | blockSize | length of the input vector
  [out] | *pResult | variance value returned here

Returns:
  none.

Scaling and Overflow Behavior:

  The function is implemented using a 64-bit internal accumulator. The input is represented in 1.15 format. Intermediate multiplication yields a 2.30 format, and this result is added without saturation to a 64-bit accumulator in 34.30 format. With 33 guard bits in the accumulator, there is no risk of overflow, and the full precision of the intermediate multiplication is preserved. Finally, the 34.30 result is truncated to 34.15 format by discarding the lower 15 bits, and then saturated to yield a result in 1.15 format.

Definition at line 61 of file arm_var_q15.c.

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Defines